// timer rb C^[o^C}ƂĎgpĂ

#include "sfr_r8m12a.h"
#include "clcd.h"
#include "wait.h"

volatile unsigned short TIMER;
volatile unsigned short KEYDATA;

void write4(unsigned char a)
{
	DI();
	CLCD_DB_W();
	CLCD_RW=0;
	CLCD_DB4=a&1;
	CLCD_DB5=(a>>1)&1;
	CLCD_DB6=(a>>2)&1;
	CLCD_DB7=(a>>3)&1;

	CLCD_E=1;
	wait10us(1);
	CLCD_E=0;
	EI();
}

void write(unsigned char a)
{
	write4((a>>4)&0x0F);	// 4rbg
	write4(a&0x0F);			// 4rbg
}

unsigned char read4(void)
{
	unsigned char a;
	DI();
	CLCD_DB_R();
	CLCD_RW=1;
	CLCD_E=1;
	wait10us(1);
	a=(CLCD_DB4+(CLCD_DB5<<1)+(CLCD_DB6<<2)+(CLCD_DB7<<3));
	CLCD_E=0;
	EI();
	return a;
}

unsigned char read(void)
{
	unsigned char a;
	return (read4()<<4)+read4();
}

unsigned char addr_r(void)
{
	unsigned char a,ret;
	CLCD_RS=0;
	for(a=0; a!=250; a++)	// rW[tO0ɂȂ܂ő҂B250*40us=10msŃ^CAEg
	{
		ret=read()&0b10000000;
		if(ret==0) break;
		wait10us(4);
	}
	return ret;
}

void busycheck(void)
{
	addr_r();
}

void inst(unsigned char a)
{
	busycheck();
	CLCD_RS=0;
	write(a);
}

void ram_w(unsigned char a)
{
	busycheck();
	CLCD_RS=1;
	write(a);
}

unsigned char ram_r(void)
{
	busycheck();
	CLCD_RS=1;
	return read();
}

void ccls(void)		// \NABȍ~ DD RAMɃANZX
{
	inst(0b00000001);
}

void chome(void)	// J[\ƕ\z[ʒuɖ߂i\e͕ێjBȍ~ DD RAMɃANZX
{
	inst(0b00000010);
}

void clocate(unsigned char x, unsigned char y)	// J[\ʒuύX
{
	inst(0b10000000|(y*0x40+x));
}

void cexchange(void)	// 1sڂ2sڂւ
{
	unsigned char pos,l1,l2;
	for(pos=0; pos!=40; pos++)
	{
		clocate(pos,0);
		l1=ram_r();
		clocate(pos,1);
		l2=ram_r();
		clocate(pos,0);
		ram_w(l2);
		clocate(pos,1);
		ram_w(l1);
	}
}

void ccll(unsigned char line)	// s̃NA J[\s̐擪
{
	unsigned char pos;
	clocate(0,line);
	for(pos=0; pos!=40; pos++)
	{
		cputch(0x20);
	}
	clocate(0,line);
}

void cvscroll(unsigned char dir)	// cXN[ 0:[_E 1:[Abv
{
	cexchange();
	ccll(dir);
}

void cdisp(unsigned char a)	// \IItRg[ bit2:\I bit1:J[\ bit0:lpJ[\
{
	inst(0b00001000 | (a & 0b00000111));
}

void centrymode(unsigned char a)	// Gg[[hZbg bit1:\Vtg bit0:AhX+
{
	inst(0b00000100 | (a & 0b00000011));
}

void cshift(unsigned char a)	// J[\ړ 0:-1 1:+1
{
	inst(0b00010000 | ((a<<2) & 0b00000100));
}

void chscrool(unsigned char dir)	// XN[ 0: 1:E
{
	inst(0b00011000 | ((dir<<2) & 0b00000100));
}

void csetcgaddr(unsigned char addr)	// CG RAMiLN^f[^jAhXZbgAȍ~ CG RAMɃANZX 
{
	inst(0b01000000 | addr & 0b00111111);
}

void csetddaddr(unsigned char addr)	// DD RAMieLXgVRAMjAhXZbgAȍ~ DD RAMɃANZX 
{
	inst(0b10000000 | addr & 0b01111111);
}

void CLCD_INIT(void)
{
	// LN^LCD̃f[^V[gɍڂĂʂ̏菇
	// ܂ŃrW[tÕ`FbN͂łȂ
	key_off();
	waitms(15);		// d15msȏ҂
	CLCD_RS=0;
	write4(0b0011);	// 8rbg[h
	waitms(5);		// 4.1msȏ҂
	write4(0b0011);	// 8rbg[h
	wait10us(15);	// 100usȏ҂
	write4(0b0011);	// 8rbg[h
	// rW[tO`FbNł
	busycheck();
	CLCD_RS=0;
	write4(0b0010);	// 4rbg[h
	inst(0b00101000);	// t@NVZbg
	cdisp(0);			// \OFF
	ccls();				// \NA
	centrymode(0b10);	// AhXZA\VtgȂ
	cdisp(0b100);		// \ONAJ[\\Ȃ
	

	DI();	// 荞݋֎~

	// TIMER RB  C^[o^C}[
	msttrb=0;	// W[X^oC
	trbcr=0b00000000;
	trbmr=0b0_111_0_1_00;	// 16rbg^C}[ f128
	// 1JEg = 1/18.432MHz * 128 = 128/18.432MHz
	// 1b = 1/128/18.432MHz = 18.432MHz/128 = 144000 JEg
	// 0.1b = 14400JEg = 0x3840
	// 0.01b = 1440JEg = 0x05A0
	trbpre=0xA0;	// 8rbg
	trbpr=0x05;		// 8rbg
	
	ilvlc=0b0000_0001;	// D惌x1
	trbie_trbir=1;	// TIMER RB 荞݋
	tstart_trbcr=1;	// TIMER RB JEgX^[g

	
}

void cputch(unsigned char a)
{
	ram_w(a);
}

void cputs(unsigned char str[])
{
	unsigned char pos=0;
	while(str[pos]!=0)
	{
		cputch(str[pos]);
		pos++;
	}
}

unsigned char ctochar(unsigned char a)
{
	if(a<10) a=a+0x30;
	else a=a+0x41-10;
	return a;
}

void cputd8(unsigned char a)
{
	cputch(ctochar(a/100));
	a=a%100;
	cputch(ctochar(a/10));
	a=a%10;
	cputch(ctochar(a));
}

void cputd16(unsigned short a)
{
	cputch(ctochar(a/10000));
	a=a%10000;
	cputch(ctochar(a/1000));
	a=a%1000;
	cputch(ctochar(a/100));
	a=a%100;
	cputch(ctochar(a/10));
	a=a%10;
	cputch(ctochar(a));
}

unsigned char keyread(void)		// L[ǂݎ(ON0)
{
	/*unsigned char ret=0;
	DI();
	key_on();
	CLCD_DB_R();
	//wait10us(1);
	ret=(CLCD_DB4+(CLCD_DB5<<1)+(CLCD_DB6<<2)+(CLCD_DB7<<3));
	key_off();
	EI();*/
	return KEYDATA;
}

unsigned char keyin(unsigned char time)		// L[ǂݎ ͂܂time*10[ms]҂ s[g(ON0)
{
	static unsigned char lastdata;
	unsigned char data;
	unsigned short delay;

	delay=TIMER+time;
	while(TIMER!=delay)	// ĂȂtime*10ms҂
	{
		data=keyread();
		if(data!=0x0F)	// Ă
		{
			if(data!=(lastdata&0x0F))	// OƈႤ
			{
				lastdata=data;
				return data;
			}
			else
			{
				//OƓ{^Ă
				if((lastdata&0xF0)==0) // 
				{
					delay=TIMER+KEYDELAY;
					while(TIMER!=delay)
					{
						data=keyread();
						if(data!=(lastdata&0x0F)) break;
					}
					lastdata=data+0x10;
					return data;
				}
		
				if((lastdata&0xF0)!=0) // ڈȍ~
				{
					delay=TIMER+KEYRATE;
					while(TIMER!=delay)
					{
						data=keyread();
						if(data!=(lastdata&0x0F)) break;
					}
					lastdata=data+0x10;
					return data;
				}
			}
		}
	}
	
	// ĂȂă^CAEg
	lastdata=0x0F;
	return 0x0F;
}

// TIMER RB A_[t[荞
// 10ms
#pragma INTERRUPT INT_trb (vect=24)
void INT_trb(void)
{
	static unsigned char lastdata;
	unsigned char a;
	
	switch(TIMER&0b11)
	{
		// 40msƂKeyǂŃ`^O
		case 0:
			key_on();
			CLCD_DB_R();
			//wait10us(1);
			a=(CLCD_DB4+(CLCD_DB5<<1)+(CLCD_DB6<<2)+(CLCD_DB7<<3));
			key_off();
	
			if(a==lastdata)	// OƓf[^Li`^Oj
			{
				KEYDATA=a;
			}
			else
			{
				KEYDATA=lastdata;
			}
			lastdata=a;
			break;
	}
	
	TIMER++;
	while(trbif_trbir==1) trbif_trbir=0;	// 荞ݗvtONA
}
