#include "sfr_r8m12a.h"
#include "trc_pwm.h"

volatile unsigned short VOLT;		// ݂̓d
volatile unsigned short AMP;		// ݂̓d
volatile unsigned short TARGETVOLT;	// ڕWd
volatile unsigned short LIMITAMP;	// d

void trc_init(void)
{
	// TIMER RC  PWM[h
	msttrc=0;	// W[X^oC
	trcmr=0b01001110;	// TRCIOC TRCIOD PWM[h
	trccr1=0b10001100;	// f1(18.432MHz) RyA}b`AŃJE^NA o͐ݒ
	asm("nop");		// 2TCN҂
	asm("nop");
	trcier=0b01110010;	// RyA}b`B 荞ݗL
	ilvl3=0b0001_0000;	// 荞ݗD惌x1
	trccr2=0b00011000;	// RyA}b`AŃJEgp o̓xLL
	trcopr=0;			// g`o͑֎~
	trccnt=0;		// JE^NA
	trcgra=1000;	// PWM 
	trcgrb=700;		// ADϊ^C~O
	trcgrc=0;
	trcgrd=0;
	pmh3=0b00000101;	// P3_4:TRCIOC P3_5:TRCIOD
	trcoer=0b01110011;	// TRCIOC TRCIOD o͋ 
	cts_trcmr=1;	// TIMER RC X^[g
}

// dvZ
// ߂l10{ i100Ȃ10.0V 1Ȃ0.1Vj
unsigned char getvolt(void)
{
	/*
	V=((22+3.9)/3.9)*(5/1024)*ad [V]
	=((220+39)/39)*(5/1024)*ad [V]
	=((220+39)*5*ad)/(39*1024)
	=(ad*1295)/39936
	*/
	return (unsigned char)((unsigned long)VOLT*12950/39936);
}

// dvZ
// ߂l10{@i10Ȃ1A 1Ȃ0.1Aj
unsigned char getamp(void)
{
	/*
	A=V/1[]	1VȂ1A 0.1VȂ100mA
	V=ad*5/1024
	*/
	return (unsigned char)((unsigned long)AMP*50/1024);
}

// ڕWdADlvZ
unsigned short volttoad(unsigned char volt)
{
	/*
	V=ad*12950/39936
	ad=V*39936/12950
	*/
	return (unsigned short)(((unsigned long)volt)*39936/12950);
}

// dADlvZ
unsigned short amptoad(unsigned char amp)
{
	/*
	A=ad*500/1024
	ad=A*1024/500
	*/
	return (unsigned short)(((unsigned long)amp)*1024/50);
}

// ڕWdZbg
void setvolt(unsigned char volt)
{
	TARGETVOLT=volttoad(volt);
}

// dZbg
void setamp(unsigned char amp)
{
	LIMITAMP=amptoad(amp);
}

// TIMER RC RyA}b`B 荞
// 1000NbNƁi1000/18432000=543usj
#pragma INTERRUPT INT_trc (vect=7)
void INT_trc(void)
{
	if(adst==0)	// ADϊIĂ
	{
		VOLT=ad0;
		AMP=ad1;
		adst=1;	// ADϊX^[g
		
		if((AMP>LIMITAMP)&&(trcgrc!=0)) trcgrc--;	// dȏȂo͌炷
		else
		{
			if((VOLT>TARGETVOLT)&&(trcgrc!=0)) trcgrc--;		// ݒdȏȂo͌炷
			if((VOLT<TARGETVOLT)&&(trcgrc<(trcgra-1))) trcgrc++;	// ݒdȉȂo͑₷
		}
		//trcgrc=500;
		//if((VOLT>TARGETVOLT)&&(trcgrc!=0)) trcgrc--;		// ݒdȏȂo͌炷
		//if((VOLT<TARGETVOLT)&&(trcgrc<trcgra)) trcgrc++;	// ݒdȉȂo͑₷
	}
	while(imfb_trcsr==1) imfb_trcsr=0;	// CvbgLv`A荞݃tONA
}
